{ Este programa controla uma rede de terminais RS-485 com comutadora paralela,
  atravs da Dll Wtechlpt.dll. Sistemas Operacionais Win2000 e XP ou superior,
  no permitem acesso direto a porta paralela, para estes S.O. deve-se instalar
  o Driver port95nt, sendo que para funcione de forma correta, deve-se estar Logado
  como "Administrador" e com "Senha". }

unit uTerminaisParalela;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Grids, ComCtrls;

type
  TfmTerminaisLPT = class(TForm)
    btInicia: TButton;
    btFechar: TButton;
    tmParalela: TTimer;
    sgBD: TStringGrid;
    procedure btFecharClick(Sender: TObject);
    procedure btIniciaClick(Sender: TObject);
    procedure tmParalelaTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const
  NTerminal = 32; // nmero de terminais na rede

var
  fmTerminaisLPT: TfmTerminaisLPT;

  teclado: array [0 .. NTerminal - 1] of string; // buffer de teclado
  waitkbd: array [0 .. NTerminal - 1] of boolean; // flag de espera de digitacao
  pikture: array [0 .. NTerminal - 1] of string; // picture esperada
  pospic: array [0 .. NTerminal - 1] of integer; // posicao dentro da picture que devemos receber
  estado: array [0 .. NTerminal - 1] of integer;
  // estado de execucao do programa
  Proximo_estado: array [0 .. NTerminal - 1] of integer;
  // estado de execucao do programa
  pprinter: array [0 .. NTerminal - 1] of string;
  // buffer de impressora paralela
  sprinter: array [0 .. NTerminal - 1] of string; // buffer de impressora serial
  pinpos: array [0 .. NTerminal - 1] of integer;
  // posicao de entrada do buffer de paralela
  poutpos: array [0 .. NTerminal - 1] of integer;
  // posicao de saida do buffer de paralela
  sinpos: array [0 .. NTerminal - 1] of integer;
  // posicao de entrada do buffer de serial
  soutpos: array [0 .. NTerminal - 1] of integer;
  // posicao de saida do buffer de serial

  // variveis da aplicao
  Usuario: array [0 .. NTerminal - 1] of string;
  Comanda: array [0 .. NTerminal - 1] of string;
  produto: array [0 .. NTerminal - 1] of String;
  quantidade: array [0 .. NTerminal - 1] of string;

  PedidoPeso: array [0 .. NTerminal - 1] of byte; // delai exibe msg e volta o estado
  TimeOutPedidoPeso: array[0..Nterminal - 1] of TTime;
  Ind_Produto: array [0 .. NTerminal - 1] of integer;

  // declarao das funes contidas na Dll Wtechlpt.dll
function ConfigLpt(Endereco, Timeout: Word): boolean; stdcall;
external 'WTechLpt.dll';
procedure Dll_Close(); stdcall; external 'WTechLpt.dll';
procedure Dll_PosCur(Terminal, Lin, Col: byte); stdcall;
external 'WTechLpt.dll';
procedure Dll_Clear(Terminal: byte); stdcall; external 'WTechLpt.dll';
procedure Dll_Echo(Terminal: byte; CharDado: char); stdcall;
external 'WTechLpt.dll';
procedure Dll_Display(Terminal: byte; StrDado: AnsiString); stdcall;
external 'WTechLpt.dll';
function Dll_Get(Terminal: byte): char; stdcall; external 'WTechLpt.dll';
function Dll_Print(Terminal: byte; CharDado: char): byte; stdcall;
external 'WTechLpt.dll';
function Dll_Serial(Terminal: byte; CharDado: char): byte; stdcall;
external 'WTechLpt.dll';
function Dll_Serial0(Terminal: byte; CharDado: char): byte; stdcall;
external 'WTechLpt.dll';
function Dll_Acesso(Cmd: string): integer; stdcall;
external 'WTechLpt.dll';

implementation

{$R *.DFM}

procedure Gdisplay(Terminal: byte; StrDados: string);
begin
  // Escreve a string correspondente no terminal selecionado
  Dll_Display(Terminal, Ansistring(StrDados));
end;

procedure Gecho(Terminal: byte; CharDados: char);
// Escreve o caracter correspondente no terminal selecionado
begin
  Dll_Echo(Terminal, CharDados);
end;

procedure GPosCursor(Terminal: byte; linha: integer; coluna: integer);
// Posiciona o cursor na linha e coluna desejadas
// linha 0 ou 1, coluna 0  39
begin
  Dll_PosCur(Terminal, linha, coluna);
end;

procedure Gclear(Terminal: byte);
// Limpa o display do terminal
begin
  Dll_Clear(Terminal);
end;

// Funcao de pedido de entrada de dados.
// As pictures validas sao:
// 9 - caracter numerico
// A - caracter alfabetico
// X - qualquer caracter
// * - Senha
// #3 - ETX do final do protocolo da balana
// . - posicao decimal ( so em campo numerico )
// / - separador de campo( so em campo numerico )
procedure Gget(Terminal: byte; StrDados: string);
begin
  if (waitkbd[Terminal] = false) then
  begin
    waitkbd[Terminal] := true;
    pospic[Terminal] := 1;
    pikture[Terminal] := StrDados;
    teclado[Terminal] := '';
  end;
end;

function Ginicia(): boolean;
// Inicializa funcionamento do microterminal
var
  i: integer;
begin
  // Configura porta e timeOut
  if ConfigLpt(StrToInt('$378'), 1000) then
  begin
          result := true;
          for i := 0 to NTerminal - 1 do
          begin
            estado[i] := 0;
            pikture[i] := '';
            pospic[i] := 1;
            waitkbd[i] := false;
            pinpos[i] := 1;
            pprinter[i] := '';
            poutpos[i] := 1;
            sprinter[i] := '';
            sinpos[i] := 1;
            soutpos[i] := 1;
            Gclear(i);
            Gclear(i);
          end;

  end
  else
    result := false;
end;

procedure gAjustaPonto(Terminal: byte);
// Testa se a tecla ponto foi pressionada
var
  PosPonto: integer;
  StrDisp: string;
  spPic: integer;
begin
  PosPonto := 1;
  while (copy(pikture[Terminal], PosPonto, 1) <> '.') do
  begin
    PosPonto := PosPonto + 1;
    if PosPonto >= length(pikture[Terminal]) then
    begin
      Exit;
    end;
  end;
  if PosPonto >= length(pikture[Terminal]) then
  begin
    Exit;
  end;
  spPic := PosPonto - 1 - length(teclado[Terminal]);
  StrDisp := '';
  while spPic > 0 do
  begin
    StrDisp := StrDisp + ' ';
    spPic := spPic - 1;
  end;
  StrDisp := StrDisp + teclado[Terminal];
  spPic := pospic[Terminal];
  While spPic > 1 do
  begin
    Gecho(Terminal, chr(8));
    spPic := spPic - 1;
  end;
  pospic[Terminal] := PosPonto;
  Gdisplay(Terminal, StrDisp);
  teclado[Terminal] := StrDisp;
end;

// Funcao de tratamento do teclado do terminal.
// Pede tecla e faz a consistencia com a picture
// solicitada na funcao GGET, aceitando ou rejeitando
// o que for digitado no terminal.
// Tambem faz o tratamento do // DEL//  do terminal,
// limpando o campo quando tem algum caracter digitado
// ou retornando ESC quando nao tinha nada digitado.
// O retorno desta funcao sera:
// false - quando a picture solicitada no
// ultimo gget nao tiver sido digitada.
// true - quando a picture tiver sido digitada
// completamente ou o CR foi digitado antes do final.
function GtrTecla(Terminal: byte): boolean;
// Trata tecla que foi pressionada
var
  gPict: string;
  stecla: char;
  tamanho: integer;
begin
  // no espera por tecla
  if (waitkbd[Terminal] = false) then
  begin
    result := false;
    Exit;
  end;

  stecla := Dll_Get(Terminal);

  // tratamento tecla especial (NULO, ENTER, DEL, BACKSPACE)
  if stecla = chr(0) then
  begin
    result := false;
    Exit;
  end
  else if (stecla = chr(13)) then // tecla enter
  begin
    waitkbd[Terminal] := false;
    result := true;
    Exit;
  end
  else if stecla = chr(127) then // tecla Del
  begin
    if pospic[Terminal] = 1 then
    begin
      teclado[Terminal] := stecla;
      waitkbd[Terminal] := false;
      result := true;
    end
    else
    begin
      while pospic[Terminal] > 1 do
      begin
        Gecho(Terminal, chr(8));
        pospic[Terminal] := pospic[Terminal] - 1;
      end;
      teclado[Terminal] := '';
      result := false;
    end;
    Exit;
  end
  else if stecla = chr(8) then // tecla backspace
  begin
    if pospic[Terminal] > 1 then
    begin
      gPict := copy(pikture[Terminal], pospic[Terminal] - 1, 1);
      if (gPict = '/') or (gPict = '.') then
      begin
        pospic[Terminal] := pospic[Terminal] - 1;
        Gecho(Terminal, chr(8));
      end;
      dec(pospic[Terminal]);
      delete(teclado[Terminal], pospic[Terminal], 1);
      Gecho(Terminal, chr(8));
    end;
    result := false;
    Exit;
  end;

  // Tratamento tecla vlida.
  gPict := copy(pikture[Terminal], pospic[Terminal], 1);

  if gPict = #3 then
  begin
    if stecla = #3 then // todo peso foi recebido
    begin
      teclado[Terminal] := teclado[Terminal] + stecla;
      waitkbd[Terminal] := false;
      result := true;
      Exit;
    end
    else
    begin
      teclado[Terminal] := teclado[Terminal] + stecla;
    end;

  end
  else if gPict = 'X' then // qualquer tecla
  begin
    teclado[Terminal] := teclado[Terminal] + stecla;
    pospic[Terminal] := pospic[Terminal] + 1;
    Gecho(Terminal, stecla);
  end
  else if gPict = '9' then // Somente aceitar numeros e "." ou "/" ou "-"
  begin
    // if ((sTecla >= '0') and (sTecla <= '9')) or (sTecla = '.') or (sTecla = '/')or (sTecla = '-') then

    if AnsiChar(stecla) in ['0' .. '9', '.', '/', '-'] then
    begin
      if stecla = '.' then
        gAjustaPonto(Terminal)
      else
      begin
        teclado[Terminal] := teclado[Terminal] + stecla;
        pospic[Terminal] := pospic[Terminal] + 1;
        Gecho(Terminal, stecla);
      end;
    end;
  end
  else if gPict = 'A' then // Alfabetico
  begin
    if AnsiChar(stecla) in ['A' .. 'Z'] then
    begin
      teclado[Terminal] := teclado[Terminal] + stecla;
      pospic[Terminal] := pospic[Terminal] + 1;
      Gecho(Terminal, stecla);
    end;
  end
  else if gPict = '*' then // Senha
  begin
    If AnsiChar(stecla) in ['0' .. '9'] Then // caso apenas nmero
    begin
      teclado[Terminal] := teclado[Terminal] + stecla;
      pospic[Terminal] := pospic[Terminal] + 1;
      Gecho(Terminal, '*');
    end;
  end
  else
  begin
    result := false;
    Exit;
  end;

  tamanho := length(pikture[Terminal]) + 1;
  gPict := copy(pikture[Terminal], pospic[Terminal], 1);
  if tamanho = pospic[Terminal] then
  begin
    waitkbd[Terminal] := false;
    result := true;
  end
  else if gPict = '/' then
  begin
    stecla := '/';
    pospic[Terminal] := pospic[Terminal] + 1;
    Gecho(Terminal, stecla);
    result := false;
  end
  else if gPict = '.' then
  begin
    stecla := '.';
    pospic[Terminal] := pospic[Terminal] + 1;
    Gecho(Terminal, stecla);
    result := false;
  end
  else
  begin
    result := false;
  end;

end;

procedure GPrintp(term: integer; StrDados: string);
begin
  pinpos[term] := pinpos[term] + length(StrDados);
  pprinter[term] := pprinter[term] + StrDados;
end;

procedure GPrints(term: integer; StrDados: string);
begin
  sinpos[term] := sinpos[term] + length(StrDados);
  sprinter[term] := sprinter[term] + StrDados;
end;

procedure GBalanca(term: integer;Porta:byte);
begin
      if Porta = 0 then
      Dll_Serial0(Term,#5)
      else
          Dll_Serial(Term,#5)
end;


// Funo que verifica se o terminal corrente tem algum dado a ser impresso
// na porta paralela
procedure GFlushPrn(Terminal: byte);
var
  Aux: string;
  NBytes_Envio: byte; // Numero de bytes a ser enviando para a serial a cada passada
  Falha_Envio: integer; // Contador de falha de envio
begin
  if (pinpos[Terminal] <> poutpos[Terminal]) then
  // se h dados a serem impressos
  begin
    NBytes_Envio := 0;
    Falha_Envio := 0; // a cada passada envia 30 bytes por terminal
    while (NBytes_Envio < 30) and (pinpos[Terminal] <> poutpos[Terminal]) do
    begin
      Aux := pprinter[Terminal][poutpos[Terminal]];
      if Dll_Print(Terminal, Aux[1]) <> 0 then
      // se conseguiu escrever o byte, avana
      begin
        poutpos[Terminal] := poutpos[Terminal] + 1;
        Falha_Envio := 0;
        inc(NBytes_Envio);
      end
      else
        inc(Falha_Envio);

      if Falha_Envio >= 50 then // se no conseguiu escrever por 50 vezes
      begin
        NBytes_Envio := 30;
      end;
    end; // end do while
  end
  else
  begin
    pprinter[Terminal] := '';
    pinpos[Terminal] := 1;
    poutpos[Terminal] := 1;
  end;
end;

// Funo que verifica se o terminal corrente tem algum dado a ser impresso
// na porta serial
procedure GFlushCom(Terminal: byte);
var
  Aux: string;
  NBytes_Envio: byte; // Numero de bytes a ser enviando para a serial a cada passada
  Falha_Envio: integer; // Contador de falha de envio
begin
  if (sinpos[Terminal] <> soutpos[Terminal]) then
  // se h dados a serem impressos
  begin
    NBytes_Envio := 0;
    Falha_Envio := 0; // a cada passada envia 30 bytes por terminal
    while (NBytes_Envio < 30) and (sinpos[Terminal] <> soutpos[Terminal]) do
    begin
      Aux := copy(sprinter[Terminal], soutpos[Terminal], 1);
      if Dll_Serial(Terminal, Aux[1]) <> 0 then
      // se conseguiu escrever o byte, avana
      begin
        soutpos[Terminal] := soutpos[Terminal] + 1;
        Falha_Envio := 0;
        inc(NBytes_Envio);
      end
      else
        inc(Falha_Envio);

      if Falha_Envio >= 50 then // se no conseguiu escrever por 50 vezes
      begin
        NBytes_Envio := 30;
      end;
    end; // end do while
  end
  else
  begin
    sprinter[Terminal] := '';
    sinpos[Terminal] := 1;
    soutpos[Terminal] := 1;
  end;
end;

function Pesquisa(Codigo: String): integer;
var
  i: byte;
begin
  result := -1;
  i := 1;
  while i < fmTerminaisLPT.sgBD.RowCount do
  begin
    if fmTerminaisLPT.sgBD.Cells[0, i] = Codigo then
    begin
      result := i;
      break;
    end;
    inc(i);
  end;

end;

procedure TfmTerminaisLPT.btFecharClick(Sender: TObject);
var
  i: integer;
begin
  tmParalela.Enabled := false;
  for i := 0 to NTerminal - 1 do
  begin
    Gclear(i);
    Gdisplay(i, 'Sistema Desativado!');
  end;
  Application.Terminate;
end;

procedure TfmTerminaisLPT.btIniciaClick(Sender: TObject);

begin
  if btInicia.Caption = 'Inicia' then
  begin
    if Ginicia() then
    begin
      btInicia.Caption := 'Para';
      tmParalela.Enabled := true;
    end
    else
      ShowMessage(
        'Wtechlpt.dll retornou false'#13'Veja configurao de arquivo INI'#13'Caso comutadora paralela teste funcionamento!');

    // Se liberar o programa ele enviar dados para os terminais
    // Se estiver utilizando terminal TCP-IP eles podem no estar
    // conectado e iro perder o menu inicial.

  end
  else
  begin
    Dll_Close();
    tmParalela.Enabled := false; // Finaliza Timer (Fim Programa)
    btInicia.Caption := 'Inicia';

  end;

end;

Procedure TrataTerminais(Terminal: byte);
begin
  with fmTerminaisLPT do
  begin
    { IMPORTANTE:
      - GFlushCom e GFlushPrn faz escrita do buffer de impressora na serial e paralela.
      - Est comentada aqui para evitar esta escrita sem ter um perifrico ligado na serial ou
      paralela o que certamente vai gerar mau funcionamento no terminal.

      SE TIVER UM PERIFRICO LIGADO AO TERMINAL RETIRRE DO COMENTRIO A CHAMADA ABAIXO.
      }
    GFlushCom(Terminal); // chama o descarregador de impresso serial
    GFlushPrn(Terminal); // chama o descarregador de impresso paralela

    case estado[Terminal] of // Envia dados para o display do terminal
      0:
        begin // muda o estado do terminal para pegar o retorno

          Gclear(Terminal);
          Gdisplay(Terminal, 'Usuario:');
          Gget(Terminal, '99999'); // apenas numeros com 4 dgitos
          estado[Terminal] := 1;
          {
            EXEMPLO DE OUTRAS MASCARAS DE ENTRADA DE DADOS
            Apenas alfa     -> Gget(Terminal, 'AAAAAAAAAAAAA' );
            Qualquer tecla  -> Gget(Terminal, 'XXXXXXXXXXXXXXXX' );
            Senha           -> Gget(Terminal, '***********' );
            }
        end;

      1:
        begin // Pega retorno do estado 0
          // GtrTecla() Ser True somente quando a mascara de entrada se completar  ou teclar ENTER
          // Exemplo gGet(Terminal,'9999'): Usurio digitando '1','2','3' e '4'
          If GtrTecla(Terminal) Then // Quando Teclado[terminal] for igual '123' ser false... quando presionar '4' retorna true e fianliza a mascara
          begin
            If (teclado[Terminal] = '') or (teclado[Terminal] = #127) Then
              // Se teclar ENTERou DEL volta estado
              estado[Terminal] := 0 // eficiente para montar novamente a tela quando o equipamento for desligado
            else
            begin
              estado[Terminal] := 2;
              Usuario[Terminal] := teclado[Terminal];
            end;

          end;

        end;

      2:
        begin // Envia dados para o display do terminal e muda o estado para pegar o retorno
          Gclear(Terminal);
          Gdisplay(Terminal, 'Senha:');
          Gget(Terminal, '****'); // Mascara para ecoar '*'
          estado[Terminal] := 3;
        end;

      3:
        begin
          If GtrTecla(Terminal) Then // Ser true quando digitar os 4 digitos da mascara, ou teclar ENTER
          begin
            If (teclado[Terminal] = '') or (teclado[Terminal] = #127) Then
              // Teclou ENTER ou DEL mas no digitou
              estado[Terminal] := 0 // volta estado
            else If teclado[Terminal] = '1234' Then
              // verifica a senha se correta
              estado[Terminal] := 4 // if Valida_Usuario( usuario[terminal], Teclado[Terminal] )
            else // usuario pegamos no estado 0 e 1. Teclado est valendo a senha
            begin
              Gclear(Terminal);
              Gdisplay(Terminal, 'Senha Invalida!');
              GPosCursor(Terminal, 1, 2);
              Gdisplay(Terminal, 'Aceita "1234"');
              // No exemplo aceita apenas '1234'
              estado[Terminal] := 99; // Estado morto para prender aplicao exibindo msg para o usurio
              Proximo_estado[Terminal] := 2;
              // para qual estado pretendemos enviar.
              // IMPORTANTE: Deve ser enviando para estando onde gGet()  chamado, que no nosso so os estados PARES.
              Gget(Terminal, 'X'); // permite que pressione qualquer tecla.
            end;
          end;
        end;

      4:
        begin
          Gclear(Terminal);
          Gdisplay(Terminal, 'Comanda:'); // Envia dados para o display do terminal e muda o estado para pegar o retorno.
          Gget(Terminal, '9999'); // Neste ponto j deve ter observado que no estado PAR enviamos
          estado[Terminal] := 5; // dados para o terminal e no estado IMPAR pegamos o retorno.
        end;

      5:
        begin
          if GtrTecla(Terminal) then
          begin
            If (teclado[Terminal] = '') or (teclado[Terminal] = #127) Then
              estado[Terminal] := 0
            else
            begin // Apenas para exibir no programa os dados
              estado[Terminal] := 6; // coletados, vamos aproveitar para enviar para impressora
              Comanda[Terminal] := teclado[Terminal];
            end;
          end;
        end;

      6:
        begin
          Gclear(Terminal);
          Gdisplay(Terminal, 'Produto:');
          Gget(Terminal, '99999999999999');
          estado[Terminal] := 7;
        end;

      7:
        begin
          if GtrTecla(Terminal) then
          begin
            If (teclado[Terminal] = '') or (teclado[Terminal] = #127) then
              estado[Terminal] := 0 // Se pressionar ENTER ou DEL volta para o inicio. Caso no tenha lanado item
            else
            begin
              Ind_Produto[Terminal] := Pesquisa(teclado[Terminal]);
              // faz a pesquisa do cdigo, no exemplo est psquisando o Grid
              if Ind_Produto[Terminal] = -1 then // no encontrou
              begin
                Gclear(Terminal);
                Gdisplay(Terminal, 'Produto nao');
                GPosCursor(Terminal, 1, 2);
                Gdisplay(Terminal, 'Localizado!');
                estado[Terminal] := 99;
                Proximo_estado[Terminal] := 6;
                Gget(Terminal, 'X');
              end
              else
              begin
                produto[Terminal] := sgBD.Cells[1, Ind_Produto[Terminal]];

                if sgBD.Cells[4, Ind_Produto[Terminal]] = 'KG' then
                begin
                  // produto por peso
                  estado[Terminal] := 10;
                  PedidoPeso[Terminal]:=0;
                end
                  else // produto por quantidade
                      estado[Terminal] := 8;

              end;
            end;
          end;
        end;

      8:
        begin
          Gclear(Terminal);
          Gdisplay(Terminal, 'Quantidade:');
          Gget(Terminal, '99999');
          estado[Terminal] := 9;
        end;

      9:
        begin
          if GtrTecla(Terminal) then
          begin

            if (teclado[Terminal] = #127) Then
              estado[Terminal] := 6 // Volta para produto
            else

              If (teclado[Terminal] = '') then
            begin
              estado[Terminal] := 8; // Pressionou ENTER sem digitar
            end
            else
            begin // houve digitao
              quantidade[Terminal] := teclado[Terminal];
              Gclear(Terminal);
              Gdisplay(Terminal, 'Produto:' + produto[Terminal]);
              GPosCursor(Terminal, 1, 0);
              Gdisplay(Terminal, 'Quantidade:' + quantidade[Terminal]);

              Gget(Terminal, 'X');
              estado[Terminal] := 99; // note que no programa h dois timers, neste ponto alm de poder teclar para voltar
              Proximo_estado[Terminal] := 6; // ser exibido a msg e o segundo timer que se encarregar de voltar.
{
            IMPORTANTE: Para evitar problemas de se enviar dados para a Paralela
            de um terminal sem ter impressora ligada a ela, a rotina que descarrega
            o buffer de impressora est comentada. Caso necessite imprimir use GflushCOM ou GFlushPrn

          GPrintp(Terminal, #13#10'Operador:' + Usuario[Terminal] + #13#10#13#10'Pedido: ' + Comanda[Terminal] + #13#10 +
                  quantidade[Terminal] + ' - ' + produto[Terminal] + #13#10'---------------------------'#13#10#27);
          GFlushPrn(Terminal);


          // Envia para a serial do terminal.
          GPrints(Terminal, #13#10'Operador:' + Usuario[Terminal] + #13#10#13#10'Pedido: ' + Comanda[Terminal] + #13#10 +
                  quantidade[Terminal] + ' - ' + produto[Terminal] + #13#10'---------------------------'#13#10#27);
          GFlushCom(Terminal);
}
            end;
          end;
        end;

      10:
        begin
              inc(PedidoPeso[Terminal]);
              Gclear(Terminal);
              Gdisplay(Terminal, 'Pedido de Peso[' + IntToStr(PedidoPeso[Terminal]) + ']' );
              GBalanca(Terminal,1); // Terminal e COM0 ou COM1
              TimeOutPedidoPeso[Terminal]:= Time;
              Gget(Terminal, #3);
              estado[Terminal] := 11;
        end;

      11:
        begin
          if GtrTecla(Terminal) then
          begin
                If (teclado[Terminal] = '') or (teclado[Terminal] = #127) Then
                begin // Peso no chegou, pressionou enter para digitar aquantidade
                  estado[Terminal] := 8;
                end
                else
                begin
                      quantidade[Terminal] := teclado[Terminal];
                      Gclear(Terminal);
                      Gdisplay(Terminal, 'Produto:' + produto[Terminal]);
                      GPosCursor(Terminal, 1, 0);
                      Gdisplay(Terminal, 'Quantidade:' + quantidade[Terminal]);
                      estado[Terminal] := 99;
                      Gget(Terminal, 'X');
                      Proximo_estado[Terminal] := 6;
                end;
          end
              else
                  if PedidoPeso[Terminal] > 3 then
                  begin
                      waitkbd[Terminal] := false;
                      Estado[Terminal]:=8;
                  end
                      else
                          if  (Time - TimeOutPedidoPeso[Terminal]) > StrToTime('00:00:02')   then
                          estado[Terminal] := 10;

        end;

      12:
        begin
          {
            IMPORTANTE: Para evitar problemas de se enviar dados para a Paralela
            de um terminal sem ter impressora ligada a ela, a rotina que descarrega
            o buffer de impressora est comentada. Caso necessite imprimir use GflushCOM ou GFlushPrn

          GPrintp(Terminal, #13#10'Operador:' + Usuario[Terminal] + #13#10#13#10'Pedido: ' + Comanda[Terminal] + #13#10 +
                  quantidade[Terminal] + ' - ' + produto[Terminal] + #13#10'---------------------------'#13#10#27);
          GFlushPrn(Terminal);


          // Envia para a serial do terminal.
          GPrints(Terminal, #13#10'Operador:' + Usuario[Terminal] + #13#10#13#10'Pedido: ' + Comanda[Terminal] + #13#10 +
                  quantidade[Terminal] + ' - ' + produto[Terminal] + #13#10'---------------------------'#13#10#27);
          GFlushCom(Terminal);
}
          Gclear(Terminal);
          Gdisplay(Terminal, 'Pedido: ' + Comanda[Terminal]);
          GPosCursor(Terminal, 1, 0);
          Gdisplay(Terminal, 'Fechando...');
          estado[Terminal] := 99;
          Gget(Terminal, 'X');
          Proximo_estado[Terminal] := 0;
        end;

      99:
        if GtrTecla(Terminal) then
        begin
          estado[Terminal] := Proximo_estado[Terminal];
        end;

    end; // EndCase
  end; // EndWith
end;

procedure TfmTerminaisLPT.tmParalelaTimer(Sender: TObject);
// Imprime no display o dado requerido de acordo com o estado do terminal
// correspondente.
var
  term: integer;
begin
  tmParalela.Enabled := false;
  for term := 0 to NTerminal - 1 do
    TrataTerminais(term);
  tmParalela.Enabled := true;
end;

procedure TfmTerminaisLPT.FormCreate(Sender: TObject);
var
  Arq: TextFile;
  i, j: integer;
  Dados, tmp: string;
begin


  sgBD.Cells[0, 0] := 'Codigo';
  sgBD.Cells[1, 0] := 'Desc';
  sgBD.Cells[2, 0] := 'Preo';
  sgBD.Cells[3, 0] := 'Qtde';
  sgBD.Cells[4, 0] := 'Unidade';

  if FileExists(GetCurrentDir + '\Produtos.txt') then
  begin
    AssignFile(Arq, GetCurrentDir + '\Produtos.txt');
    reset(Arq);
    j := 1;
    tmp := '';
    while not Eof(Arq) do
    begin
      sgBD.RowCount := j + 1;
      readln(Arq, Dados);

      i := 0;
      while Dados <> '' do
      begin
        if Dados[1] = ';' then
        begin
          sgBD.Cells[i, j] := tmp;
          tmp := '';
          inc(i);
        end
        else
          tmp := tmp + Dados[1];
        delete(Dados, 1, 1);
      end;

      inc(j);
    end;
    CloseFile(Arq);
  end;
end;

procedure TfmTerminaisLPT.FormDestroy(Sender: TObject);
begin
  Dll_Close();
end;

end.
